#include "main.h"


volatile struct LED_config leds[8];
volatile unsigned char theta;

void initialize_timer(void)
{
	TCCR1B = 0; //stop timer during reset
	
	OCR1A = 10;
	//WGM1 = 0b0100;
	//CS = 0b101; 64us
	TCCR1A = 0b00000000;
	TCCR1B = 0b00001101;
	TIMSK |= 0b00010000;
	TIMSK &= 0b11010011;
}

void cancel_timer(void)
{
	TIMSK &= 0b11000011;
	TCCR1A = 0b00000000;
	TCCR1B = 0b00000000;
	TCNT1 = 0;
}

void set_timer_period(unsigned int t)
{
	if (t >= 10)
	{
		ATOMIC_BLOCK(ATOMIC_RESTORESTATE)
		{
			OCR1A = t;
			if (TCNT1 >= t)
				TCNT1 = t - 1;
		}
	}
}



ISR(TIMER1_COMPA_vect)
{
	static unsigned char scaler = 0;
	if (scaler < 8)
	{
		scaler++;
		return;
	}
	theta++; //todo: make sure this doesn't invoke the compiler bug. (theta might not wrap around at 256, somehow)
}

